zoukankan      html  css  js  c++  java
  • Codeforces Round #271 (Div. 2) F.Ant colony(线段树 + 统计区间内某数的个数)

    F. Ant colony

    Mole is hungry again. He found one ant colony, consisting of n ants, ordered in a row. Each ant i (1 ≤ i ≤ n) has a strength si.

    In order to make his dinner more interesting, Mole organizes a version of «Hunger Games» for the ants. He chooses two numbers l and r(1 ≤ l ≤ r ≤ n) and each pair of ants with indices between l and r (inclusively) will fight. When two ants i and j fight, ant i gets one battle point only if si divides sj (also, ant j gets one battle point only if sj divides si).

    After all fights have been finished, Mole makes the ranking. An ant i, with vi battle points obtained, is going to be freed only if vi = r - l, or in other words only if it took a point in every fight it participated. After that, Mole eats the rest of the ants. Note that there can be many ants freed or even none.

    In order to choose the best sequence, Mole gives you t segments [li, ri] and asks for each of them how many ants is he going to eat if those ants fight.

    Input

    The first line contains one integer n (1 ≤ n ≤ 105), the size of the ant colony.

    The second line contains n integers s1, s2, ..., sn (1 ≤ si ≤ 109), the strengths of the ants.

    The third line contains one integer t (1 ≤ t ≤ 105), the number of test cases.

    Each of the next t lines contains two integers li and ri (1 ≤ li ≤ ri ≤ n), describing one query.

    Output

    Print to the standard output t lines. The i-th line contains number of ants that Mole eats from the segment [li, ri].

    Examples
    input
    5
    1 3 2 4 2
    4
    1 5
    2 5
    3 5
    4 5
    output
    4
    4
    1
    1
    Note

    In the first test battle points for each ant are v = [4, 0, 2, 0, 2], so ant number 1 is freed. Mole eats the ants 2, 3, 4, 5.

    In the second test case battle points are v = [0, 2, 0, 2], so no ant is freed and all of them are eaten by Mole.

    In the third test case battle points are v = [2, 0, 2], so ants number 3 and 5 are freed. Mole eats only the ant 4.

    In the fourth test case battle points are v = [0, 1], so ant number 5 is freed. Mole eats the ant 4.

    题意是求某个区间内能除尽区间其他所有数的数的个数。很显然只有区间内所有数的最大公因数满足这个条件。这样就转换成了一个线段树问题。查询区间内有几个满足条件的数的话使用排好序的pair数组,first保存数组,second保存下标,然后二分查找就好了。

    #include<cstdio>
    #include<cstring>
    #include<algorithm>
    using namespace std;
    #define lson l, m, rt<<1
    #define rson m+1, r, rt<<1|1
    #define ll long long
    const int maxn = 1e5 + 10;
    
    int gcd[maxn<<2];
    int Min[maxn<<2];
    typedef pair<int, int> pii;
    pii num[maxn];
    void PushUp(int rt) {
        gcd[rt] = __gcd(gcd[rt<<1], gcd[rt<<1|1]);
    }
    int cnt = 0;
    void build(int l, int r, int rt) {
        if(l == r) {
            //printf("cc %d
    ", ++tmp);
            scanf("%d", &num[++cnt].first);
            num[cnt].second = cnt;
            gcd[rt] = num[cnt].first;
            return;
        }
        int m = (l + r) >> 1;
        build(lson);
        build(rson);
        PushUp(rt);
    }
    
    int query(int L, int R, int l, int r, int rt) {
        if(L <= l && r <= R) {
            return gcd[rt];
        }
        int a = 0, b = 0;
        int m = (l + r) >> 1;
        if(L <= m) a = query(L, R, lson);
        if(m < R) b = query(L, R, rson);
        return __gcd(a, b);
    }
    
    int main() {
        int n;
        scanf("%d", &n);
        build(1, n, 1);
        int q;
        sort(num + 1, num + 1 + n);
        scanf("%d", &q);
        while(q--) {
            int a, b;
            scanf("%d %d", &a, &b);
            int gcd = query(a, b, 1, n, 1);
            int l = lower_bound(num + 1, num + 1 + n, pii(gcd, a)) - (num + 1);
            int r = lower_bound(num + 1, num + 1 + n, pii(gcd, b + 1)) - (num + 1);
            printf("%d
    ", (b - a + 1) - (r - l));
            cnt = 0;
        }
    }

    ps:一道水水的cf的F题真是涨自信...orz

  • 相关阅读:
    Handler详细说明系列(六)——View的post()详解
    2013年6月17日星期一
    2013年6月16日星期日
    线程管理四种方法
    java 线程 ProducerAndConsumer
    POJ 2948 DP
    Java的递归算法
    开机黑屏 仅仅显示鼠标 电脑黑屏 仅仅有鼠标 移动 [已成功解决]
    网络安全审查制度即将推出 手机App安全加密成必定趋势
    递归算法浅谈
  • 原文地址:https://www.cnblogs.com/lonewanderer/p/5658574.html
Copyright © 2011-2022 走看看